/***** spin: pangen3.h *****/

/* Copyright (c) 1991-1998 by Lucent Technologies - Bell Laboratories     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* Permission is given to distribute this code provided that this intro-  */
/* ductory message is not removed and no monies are exchanged.            */
/* No guarantee is expressed or implied by the distribution of this code. */
/* Software written by Gerard J. Holzmann as part of the book:            */
/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */
/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */
/* Send bug-reports and/or questions to: gerard@research.bell-labs.com    */

/* dSpin extension written by Radu Iosif. Feedback: iosif@athena.polito.it */


static char *Addp0[] = {
        ")",
        "{",
        "  P *o_this = this;",
	"  int h = _addproc(n);",
	"  int _t = Q_LOCAL;",
	"#ifdef POSYMM",
	"  scalar_t *_s = (scalar_t *) 0;",
	"#endif /* POSYMM */",
	"  int II = h;\n",
        0,
};


static char *Addp1[] = {
        "  this = pptr(h);",
	"",
        "  switch (n) {",
        0,
};

static char *Addq0[] = {
        "#ifdef POSYMM",
	"int addqueue(int tag, int id, int n, int is_rv, scalar_t *s)",
	"#else",
	"int addqueue(int tag, int id, int n, int is_rv)",
	"#endif /* POSYMM */",
	"{",
        "  int j, align = 0;",
	"",
	"  switch (n) {",
	0,
};


static char *Addq1[] = {
	"  default: Uerror(\"bad queue - addqueue\");",
	"  }\n",
	"#ifdef POSYMM",
	"  return _addq(tag, id, n, j, align, s);",
	"#else",
	"  return _addq(tag, id, n, j, align);",
	"#endif /* POSYMM */",
	"}\n\n",
	0,
};


static char *Addq11[] = {
	"{",
	"  int j, k; uchar *z;\n",
	"  if (!into --)",
	"    uerror(\"ref to deleted/uninitialized chan name (sending)\");\n",
	"  if (into < 0 || q_free(into))",
	"    Uerror(\"qsend bad queue#\");\n",
	"  z = (uchar *)qptr(into);",
	"  j = qptr(into)->Qlen;\n",
	"  switch (qptr(into)->_t) {",
	0,
};


static char *Addq2[] = {
	"  case 0: printf(\"queue %%d was deleted\\n\", into+1);",
	"  default: Uerror(\"bad queue - qsend\");",
	"  }\n",
	"#ifdef EVENT_TRACE",
	"  if (in_s_scope(into + 1))",
	"    require('s', into);",
	"#endif",
	"}\n\n",
	"#if SYNC",
	"int q_zero(int from)",
	"{",
	"  if (!from --)",
	"    uerror(\"ref to deleted/uninitialized chan name (q_zero)\");\n",
	"  if (from < 0 || q_free(from))",
	"    Uerror(\"q_zero bad queue#\");\n",
	"  switch(qptr(from)->_t) {",
	0,
};


static char *Addq3[] = {
	"  case 0: printf(\"queue %%d was deleted\\n\", from + 1);",
	"  }\n",
	"  Uerror(\"bad queue q-zero\");",
	"  return 0; /* unreached */",
	"}\n\n",
	"int not_RV(int from)",
	"{",
	"  if (q_zero(from)) {",
	"    printf(\"==>> a test of the contents of a rv \");",
	"    printf(\"channel always returns FALSE\\n\");",
	"    uerror(\"error to poll rendezvous channel\");",
	"  }\n",
	"  return 1;",
	"}",
	"#endif /* SYNC */",
	"\n",
	"#ifndef XUSAFE",
	"void setq_claim(int x, int m, char *s, int y, char *p)",
	"{",	
	"  if (!x --)",
	"    uerror(\"x[rs] claim on uninitialized channel\");\n",
	"  if (x < 0 || q_free(x))",
	"    Uerror(\"cannot happen setq_claim\");\n",
	"  q_claim[x] |= m;",
	"  p_name[y] = p;",
	"  q_name[x] = s;",
	"  if (m & 2) q_S_check(x + 1, y);",
	"  if (m & 1) q_R_check(x + 1, y);",
	"}\n",
	"short q_sender[MAXQ + 1];\n",
	"int q_S_check(int x, int who)",
	"{",
	"  if (!x --)",
	"    uerror(\"x[rs] claim on uninitialized channel\");\n",
	"  if (x < 0 || q_free(x))",
	"    Uerror(\"cannot happen q_S_claim\");\n",
	"  if (!q_sender[x]) {",
	"    q_sender[x] = who + 1;",
	"#if SYNC",
	"    if (q_zero(x)) {",
	"      printf(\"chan %%s (%%d), \", q_name[x], x - 1);",
	"      printf(\"sndr proc %%s (%%d)\\n\", p_name[who], who);",
	"      uerror(\"xs chans cannot be used for rv\");",
	"    }",
	"#endif",
	"  } else {",
	"     if (q_sender[x] != who + 1) {",
	"       printf(\"pan: xs assertion violated: \");",
	"       printf(\"access to chan <%%s> (%%d)\\npan: by\",",
	"                q_name[x], x - 1);",
	"       printf(\"%%s (proc %%d) and by %%s (proc %%d)\\n\",",
	"                p_name[q_sender[x] - 1], q_sender[x] - 1,",
	"                p_name[who], who);",
	"       uerror(\"error, partial order reduction invalid\");",
	"     }",
	"   }\n",
	"  return 1;",
	"}\n",
	"short q_recver[MAXQ+1];\n",
	"int q_R_check(int x, int who)",
	"{",
	"  if (!x --)",
	"    uerror(\"x[rs] claim on uninitialized channel\");\n",
	"  if (x < 0 || q_free(x))",
	"    Uerror(\"cannot happen q_R_check\");\n",
	"  if (!q_recver[x]) {",
	"    q_recver[x] = who + 1;",
	"#if SYNC",
	"    if (q_zero(x)) {",
	"      printf(\"chan %%s (%%d), \", q_name[x], x - 1);",
	"      printf(\"recv proc %%s (%%d)\\n\", p_name[who], who);",
	"      uerror(\"xr chans cannot be used for rv\");",
	"    }",
	"#endif",
	"  } else {",
	"     if (q_recver[x] != who + 1) {",
	"       printf(\"pan: xr assertion violated: \");",
	"       printf(\"access to chan %%s (%%d)\\n\",",
	"                q_name[x], x-1);",
	"       printf(\"pan: by %%s (proc %%d) \",",
	"                p_name[q_recver[x]-1], q_recver[x]-1);",
	"       printf(\"and by %%s (proc %%d)\\n\",",
	"                p_name[who], who);",
	"       uerror(\"error, partial order reduction invalid\");",
	"     }",
	"  }\n",
	"  return 1;",
	"}",
	"#endif\n\n",
	"int q_len(int from)",
	"{",
	"  if (!from --)",
	"    uerror(\"ref to deleted/uninitialized chan name (len)\");\n",
	"  return qptr(from)->Qlen;",
	"}\n\n",
	"int q_full(int from)",
	"{",
	"  if (!from --)",
	"    uerror(\"ref to deleted/uninitialized chan name (qfull)\");\n",
	"  if (from < 0 || q_free(from))",
	"    Uerror(\"q_full bad queue#\");\n",
	"  switch (qptr(from)->_t) {",
	0,
};


static char *Addq4[] = {
	"  case 0: printf(\"queue %%d was deleted\\n\", from + 1);",
	"  }\n",
	"  Uerror(\"bad queue - q_full\");",
	"  return 0;",
	"}\n\n",
	"int qrecv(int from, int slot, int fld, int done)",
	"{",	
	"  Q *z;",
	"  int j, k, r = 0;\n",
	"  if (!from --)",
	"    uerror(\"ref to deleted/uninitialized chan name (recv)\");\n",
	"  if (from < 0 || q_free(from))",
	"    Uerror(\"qrecv bad queue#\");\n",
	"  z = qptr(from);\n",
	"#ifdef EVENT_TRACE",
	"  if (done && (in_r_scope(from + 1)))",
	"    require('r', from);",
	"#endif\n",
	"  switch (qptr(from)->_t) {",
	0,
};


static char *Addq5[] = {
	"  case 0: printf(\"queue %%d was deleted\\n\", from + 1);",
	"  default: Uerror(\"bad queue - qrecv\");",
	"  }\n",
	"  return r;",
	"}\n",
	0,
};


static char *Addh0[] = {
        "#ifdef POSYMM",
	"uint addheap(int t, int n, scalar_t *_s)",
	"#else",
        "uint addheap(int t, int n)",
	"#endif /* POSYMM */",
	"{",
	"  int sz, k, base;",
	"  int h, _t = Q_HEAP;",
	"  uint ptr, type;",
	"",
	"  switch (t) {",
	0,
};


static char *Addh1[] = {
        "  }",
	"",
	"  if (n >= (1 << 24))",
	"    printf(\"warning: array bound too big\\n\");",
	"",
	"  type |= (n << 8);",
	"#ifdef POSYMM",
	"  k = _addheap(n * sz, type, _s);",
	"#else",
	"  k = _addheap(n * sz, type);",
	"#endif /* POSYMM */",
	"  ptr = mp(k, 0, HPTR);",
	"  h = k;",
	"",
	"  for (base = 0; base < n * sz; base += sz)",
	"    switch (t) {",
	0,
};


static char *Addh2[] = {
        "    }",
	"",
	"  return ptr;",
	"}\n\n",
	"void gc_rec(int);",
	"",
	"void delheap(uint ptr)",
	"{",
	"  int base, k;",
	"  register int i;",
	"",
	"  k = d_index(ptr);",
	"#ifdef GC0",
	"  gc_rec(k);",
	"  _delheap(k);",
	"  for (i = 0; i < MAXHEAP; i ++)",
	"    if (!h_free(i) && !h_ref(i))",
	"      _delheap(i);",
	"#else /* GC0 */",
	"  _delheap(k);",
	"#endif /* GC0 */",
	"}\n\n",
	"#ifdef GC0",
	"inline void __gc_dec(uint, int);",
	"",
	"void gc_rec(int k)",
	"{",
	"  int base;",
	"",
	"  for (base = 0; base < (h_type(k) >> 8);)",
	"    switch (h_type(k) & 255) {",
	"      default: return;\n",
	0,
};


static char *Addh3[] = {
        "    }",
	"}",
	"#endif /* GC0 */\n\n",
	"#ifdef GC1",
	"void gc_mark(uint ptr)",
	"{",
	"  int base, k;",
	"",
	"  k = h_index(ptr);",
	"",
	"  if (k >= 0 && !h_free(k) && h_mark[k] == -1)",
	"    {",
	"      h_mark[k] = h_ordinal ++;",
	"",
	"      for (base = 0; base < (h_type(k) >> 8);)",
	"        switch (h_type(k) & 255) {",
	"          default: return;\n",
	0,
};


static char *Addh4[] = {
        "        }",
	"    }",
	"}",
	"#endif /* GC1 */\n\n",
	"#ifndef NOSYMM",
	"void fields_ptr_reloc(int k, int threshold, int inc, int del)",
	"#else",
	"void fields_ptr_remove(int k, int del)",
	"#endif /* NOSYMM */",
	"{",
	"  int i, base;",
	"",
	"  for (base = 0; base < (h_type(k) >> 8);)",
	"    switch (h_type(k) & 255) {",
	"      default: return;\n",
	0,
};


static char *Addh5[] = {
	"    }",
	"}\n\n",
	"#ifndef NOSYMM",
	"void fields_chan_reloc(int k, int threshold, int inc, int del)",
	"#else",
	"void fields_chan_remove(int k, int del)",
	"#endif /* NOSYMM */",
	"{",
	"  int base;",
	"",
	"  for (base = 0; base < (h_type(k) >> 8);)",
	"    switch (h_type(k) & 255) {",
	"      default: return;\n",
	0,
};


static char *Addh6[] = {
        "    }",
	"}\n\n",
	"#ifdef FULLSYMM",
	"void fields_ptr_perm(int k, int *p, int l)",
	"{",
	"  int i, base;",
	"",
	"  for (base = 0; base < (h_type(k) >> 8);)",
	"    switch (h_type(k) & 255) {",
	"      default: return;\n",
	0,
};


static char *Addh7[] = {
        "    }",
	"}\n\n",
	"void fields_chan_perm(int k, int *p, int l)",
	"{",
	"  int i, base;",
	"",
	"  for (base = 0; base < (h_type(k) >> 8);)",
	"    switch (h_type(k) & 255) {",
	"      default: return;\n",
	0,
};


static char *Addh8[] = {
        "    }",
	"}",
	"#endif /* FULLSYMM */\n\n",
	0,
};


static char *Code0[] = {
	"void run(void)",
	"{",
	"  int i;",
	"",
	"  memset((char *)&now, 0, sizeof(State));",
	"  now.heap = (uchar *) emalloc(HEAPSZ);",
	"  memset((char *)&A_Root, 0, sizeof(State));",
	"  A_Root.heap = (uchar *) emalloc(HEAPSZ);",
	"",
	"  settable();",
	"",
	"  for (i = 0; i < MAXPROC+1; i ++)",
	"    rt[i] = vt[i] = 0;",
	"",
	"  for (i = 0; i < MAXQ; i ++)",
	"    q_offset(i) = -1;",
	"",
	"  for (i = 0; i < MAXHEAP; i ++) {",
	"    h_offset(i) = -1;",
	"#ifdef GC1",
	"    h_mark[i] = -1;",
	"#endif /* GC1 */",
	"  }",
	"",
	0,
};

static char *R0[] = {
	"  reached[%d] = reached%d;",
	"  accpstate[%d] = (uchar *) emalloc(nstates%d);",
	"  progstate[%d] = (uchar *) emalloc(nstates%d);",
	"  stopstate[%d] = (uchar *) emalloc(nstates%d);",
	"  visstate[%d] = (uchar *) emalloc(nstates%d);",
	"  stopstate[%d][endstate%d] = 1;",
	0,
};

static char *R0a[] = {
	"  retrans(%d, nstates%d, start%d, src_ln%d, reached%d);",
	"",
	0,
};

static char *R0b[] = {
	"  if (state_tables) {",
	"    printf(\"\\nTransition Type: \");",
	"    printf(\"A=atomic; D=d_step; L=local; G=global\\n\");",
	"    printf(\"Source-State Labels: \");",
	"    printf(\"p=progress; e=end; a=accept;\\n\");",
	"    exit(0);",
	"  }",
	"",
	0,
};

static char *Code1[] = {
	"#ifdef NP",
	"#define ACCEPT_LAB	1 /* at least 1 in np_ */",
	"#else",
	"#define ACCEPT_LAB	%d /* user-defined accept labels */",
	"#endif /* NP */",
	0,
};

static char *Code3[] = {
	"#define PROG_LAB	%d /* progress labels */",
	0,
};

static char *R2[] = {
	"uchar *accpstate[%d];",
	"uchar *progstate[%d];",
	"uchar *reached[%d];",
	"uchar *stopstate[%d];",
	"uchar *visstate[%d];",
	0,
};


static char *R4[] = {
	"  r_ck(reached%d, nstates%d, %d, src_ln%d);",
	0,
};

static char *R6[] = {
	"  }",
	"",
	"  this = o_this;",
	"  return h - BASE;",
	"}\n\n",
	0,
};

static char *R9[] = {
	"\ntypedef struct Q%d {",
	"  uchar Qlen;	/* q_size */",
	"  uchar _t;	/* q_type */\n",
	"  struct {",
	0,
};

static char *R10[] = {
        "/*** Generic queue type ***/\n",
	"typedef struct Q {",
	"  uchar Qlen;",
        "  uchar _t;",
	"} Q;\n\n",
	0,
};

static char *R12[] = {
	"    case %d: r = ((Q%d *)z)->contents[slot].fld%d; break;",
	0,
};

char *R13[] = {
	"int unsend(int into)",
	"{",
	"  int m = 0, j, k;",
	"  Q *z;\n",
	"  if (!into --)",
	"    uerror(\"ref to deleted/uninitialized chan (unsend)\");\n",
	"  if (into < 0 || q_free(into))",
	"    Uerror(\"unsend bad queue#\");\n",
	"  z = qptr(into);",
	"  j = z->Qlen;",
	"  z->Qlen = -- j;\n",
	"  switch (qptr(into)->_t) {",
	0,
};

char *R14[] = {
        "  default: Uerror(\"bad queue - unsend\");",
	"  }\n",
	"  return m;",
	"}\n\n",

	"void unrecv(int from, int slot, int fld, int fldvar, int strt)",
	"{",
	"  int j;",
	"  Q *z;\n",
	"  if (!from --)",
	"    uerror(\"ref to deleted/uninitialized chan (unrecv)\");\n",
	"  if (from < 0 || q_free(from))",
	"    Uerror(\"unrecv bad queue#\");\n",
	"  z = qptr(from);",
	"  j = z->Qlen;",
	"  if (strt) z->Qlen = j + 1;\n",
	"  switch (qptr(from)->_t) {",
	0,
};

char *R15[] = {
	"  default: Uerror(\"bad queue - unrecv\");",
	"  }",
	"}\n\n",
	0,
};








